



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linq 用法笔记</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linq 用法笔记</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 08:39:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><strong>Linq中怎么用 between&hellip;and?</strong></h3>
<div>
<div>
<pre class="prettyprint linenums"> var query = from p in context.Parent<br />
            from c in context.Child.Where(x =&gt; p.cob &gt;= x.effective)<br />
                                   .Where(x =&gt; p.cob &lt;= x.expiry)<br />
                                   .DefaultIfEmpty()<br />
            group p by p.cob into pg<br />
            select new<br />
            {<br />
              cob = pg.Key,<br />
              count = pg.Count()<br />
            };</pre>
</div>
</div>
<p><em>下面这个是用多个where条件来处理between&hellip;and，但是是内连接。<br /></em></p>
<div>
<pre class="prettyprint linenums">var appointmentNoShow = from a in appointments<br />
                        from p in properties<br />
                        from c in clients<br />
                        where a.Id == p.OID<br />
                        where a.Start.Date &gt;= startDate.Date<br />
                        where a.Start.Date&lt;=endDate.Date</pre>
</div>
<h3>怎么用 in ？</h3>
<div>
<pre class="prettyprint linenums">var allowedStatus = new[]{ "A", "B", "C" };<br />
var filteredOrders = orders.Order.Where(o =&gt; allowedStatus.Contains(o.StatusCode));<br />
<br />or in query syntax:

 var filteredOrders = from order in orders.Order<br />
                     where allowedStatus.<strong>Contains</strong>(order.StatusCode)<br />
                     select order;</pre>
</div>
<h3>怎么使用多个连接条件 join...on ？</h3>
<div>
<pre class="prettyprint linenums">var query = from obj_i in set1<br />
join obj_j in set2 on<br />
    new {<br />
      JoinProperty1 = obj_i.SomeField1,<br />
      JoinProperty2 = obj_i.SomeField2,<br />
      JoinProperty3 = obj_i.SomeField3,<br />
      JoinProperty4 = obj_i.SomeField4<br />
    }<br />
    equals<br />
    new {<br />
      JoinProperty1 = obj_j.SomeOtherField1,<br />
      JoinProperty2 = obj_j.SomeOtherField2,<br />
      JoinProperty3 = obj_j.SomeOtherField3,<br />
      JoinProperty4 = obj_j.SomeOtherField4<br />
    }<br />http://stackoverflow.com/questions/3020442/linq-joining-in-c-sharp-with-multiple-conditions</pre>
</div>
<p>如果要达到这个sql的效果：</p>
<div>
<pre class="prettyprint linenums">SELECT * FROM table1 a<br />
LEFT JOIN table2 b ON a.col1 = b.key1 AND<br />
a.col2 = b.key2 AND<br />
b.from_date &lt;= now() AND<br />
b.deleted = 0;</pre>
</div>
<p>可以这样：</p>
<div>
<pre class="prettyprint linenums">var query = (from x in context.table1<br />
             join y in context.table2 on<br />
             new  {<br />
                  Key1 = x.col1,<br />
                  Key2 = x.col2<br />
                  Key3 = true,<br />
                  Key4 = true<br />
                  } equals<br />
     {<br />
        Key1 = b.key1,<br />
        Key2 =  b.key2,<br />
        Key3 = b.from_date&lt; DateTime.Now,<br />
        Key4 = !b.deleted<br />
     }<br />
             into result<br />
from r in result.DefaultIfEmpty()<br />
select new  {x.Something, r.Something}<br />http://stackoverflow.com/questions/7765230/linq-to-entity-multiple-join-conditions</pre>
</div>
<h3>怎么使用group ... by 分组？</h3>
<p>如sql：</p>
<div>
<pre class="prettyprint linenums">SELECT * FROM &lt;TableName&gt; GROUP BY &lt;Column1&gt;,&lt;Column2&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">group x by new { x.Column1, x.Column2 }<br />
或者：<br />
.GroupBy(x =&gt; new { x.Column1, x.Column2 })</pre>
</div>
<div>
<pre class="prettyprint linenums">var query = (from t in Transactions<br />
             group t by new {t.MaterialID, t.ProductID}<br />
             into grp<br />
                    select new<br />
                    {<br />
                        grp.Key.MaterialID,<br />
                        grp.Key.ProductID,<br />
                        Quantity = grp.Sum(t =&gt; t.Quantity)<br />
                    }).ToList();</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2jzpx8.html">Codeforces Round &num;259 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqve4jy9.html">82  fsck-检查与修复 Linux 档案系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdzw679.html">SqlServer性能优化 提高并发性能（八）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx7ymj9.html">LALR&lpar;1&rpar;语法分析生成器--xbytes</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvd31yq.html">lintcode：验证二叉查找树</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgjvoq.html">jquery中ajax向action传递对象参数，json ，spring注入对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwnme9.html">getComputedStyle和currentStyle</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn7e32q.html">Node&period;js教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k172l39.html">Socket tips&colon; UDP Echo service - Server code</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdeord8.html">PowerDesigner15在生成SQL时报错Generation aborted due to errors detected during the verification of the mod</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mj2438.html">CI如何在子目录下可以设置默认控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z065j9.html">QuickTime视频解析问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgl4de8.html">&lbrack; 学习笔记 &rsqb; Hibernate框架学习之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdlmoz9.html">插入MongoDB文档：mongo控制台查看插入到MongoDB文档中的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9502ynm8.html">Sublime2 Package Control不可用修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7npeq.html">HyperLedger Fabric ChainCode开发&mdash;&mdash;shim&period;ChaincodeStubInterface用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1gnpxq.html">vs2017无法安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r57j2mq.html">ado&period;net 批量添加 更新 删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppnwx49.html">python安装教程（Windows系统&comma;python3&period;7为例）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9027j44q.html">OpenCV&mdash;&mdash;创建Mat对象、格式化输出、常用数据结构和函数（point，vector、Scalar、Size、Rect、cvtColor）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rd776e8.html">CentOS6 root 用户 vi&sol;vim 无法开启高亮</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkj0zq.html">搭建Titanium开发环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkjlyq.html">第二百六十三天 how can I 坚持</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z4wdz9.html">Java邮件服务学习之四：邮箱服务客户端Spring Mail</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmvpz69.html">Oracle分组函数cube VS rollup</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydgopmq.html">codeforces  630C&Tab;Lucky Numbers</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvko1xq.html">POJ 3671 Dining Cows &lpar;DP，LIS， 暴力&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okypmx9.html">剑指OFFER之反转链表（九度OJ1518）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1wkrx9.html">Volley使用指南第二回（来自developer&period;android）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1wl4m9.html">非IE内核浏览器支持activex插件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
